--Background
background = Image.load("./images/memomaker.png") 

--- Load scripts
dofile("danzeff.lua")

--- Keyboard Initialization
keyboard = Danzeff:New()
oldpad=Controls.read()

-- Constants
maxnamelen=18
maxmemolen=33
sel=1

--- Field to be edited
fieldedit = 1
fieldpos = 1
textcolor = Color.new(0, 0, 0)
selecolor = Color.new(255, 255, 255)
editcolor = Color.new(0, 0, 0)
cursorcolor = Color.new(255, 250, 250)
editmode = false
newchar = 0
tickpad = 0

board = Image.createEmpty(480,272)

olddy = 2
olddx = 2
goprg = true


function DisplayScreen()

  board:blit(0, 0, background)

  if editmode then
    if fieldedit == 1 then
      board:print(23, 35, field, editcolor)
      board:print(23, 80, field2, textcolor)
      board:drawLine(23 + (fieldpos * 8), 45, 23 + ((fieldpos + 1) * 8), 45, cursorcolor)
    else
      board:print(23, 35, field, textcolor)
      board:print(23, 80, field2, editcolor)
      board:drawLine(23 + (fieldpos * 8), 90, 23 + ((fieldpos + 1) * 8), 90, cursorcolor)
    end
  else
    if fieldedit == 1 then
      board:print(23, 35, field, selecolor)
      board:print(23, 80, field2, textcolor)
    else
      board:print(23, 35, field, textcolor)
      board:print(23, 80, field2, selecolor)
    end
  end
  
  screen:blit(0,0,board)

end

--- Display screen

DisplayScreen()

screen:waitVblankStart()
screen:flip()

--- Main processing

while goprg do

	screen:clear()
	pad = Controls.read()
	DisplayScreen()

	dx = 2
	dy = 2
	if pad:analogX() < -42 then dx = 1 end
	if pad:analogX() > 42  then dx = 3 end
	if pad:analogY() < -42 then dy = 1 end
	if pad:analogY() > 42  then dy = 3 end
	if not editmode then
		if pad:cross() and oldpad:cross()~=pad:cross() then
			editmode = true
			if fieldedit == 1 then
				fieldpos = string.len(field)
			else
				fieldpos = string.len(field2)
			end
			
			-- Loads the Keyboard
			if fieldedit == 1 then
				keyboard:Init(300, 80)
			else
				keyboard:Init(300, 80)
			end

		elseif pad:triangle() then
			dofile("script.lua")
		elseif pad:square() and oldpad:square()~=pad:square() then
			dofile("help2.lua")
		elseif pad:circle() and oldpad:circle()~=pad:circle() then
			if fieldedit == 1 then 
				fieldedit = 2 
			else                   
				fieldedit = 1
			end
		elseif pad:select() and oldpad:select()~=pad:select() then
			field="Memo name"
			field2="Memo text"
		elseif pad:start() and oldpad:start()~=pad:start() then
			screen.waitVblankStart(10)
			while true do
				screen:clear()
				screen:blit(0,0,board)
				pad=Controls.read()
				if pad:up() and oldpad:up()~=pad:up() then
					sel=sel-1
				elseif pad:down() and oldpad:down()~=pad:down() then
					sel=sel+1
				end
				if sel<1 then sel=3 end
				if sel>3 then sel=1 end
				local choice={"Save","Save & Quit","Quit"}
				local chcol={editcolor,editcolor,editcolor,editcolor}
				chcol[sel]=selecolor
				screen:blit(190,106,start)
				screen:print(224,117,choice[1],chcol[1])
				screen:print(196,127,choice[2],chcol[2])
				screen:print(224,137,choice[3],chcol[3])
				if pad:start() then break end
				if pad:cross() then
					if sel==1 or sel==2 then
						local file=io.open("./memos/"..field,"w")
						file:write(field2)
						file:close()
					end
					if sel==2 or sel==3 then
						goprg = false
						background=Image.load("./images/background.png")
						tfread=false
					end
					break
				end
				screen.waitVblankStart()
				screen:flip()
				oldpad=pad
			end
		end
	end


	if editmode then

		--  Read Keyboard Input
		newchar = keyboard:Input(pad)

		--  Keyboard Input red
		if newchar == 4 or newchar == 3 then
			editmode = false
		elseif newchar == 10 then
			editmode = false
			if fieldedit == 1 then 
				fieldedit = 2 
			else                   
				fieldedit = 1
			end
		else
			if fieldedit == 1 then
				newfield = field
			else
				newfield = field2
			end 
			if newchar == 1 then
				if fieldpos > 0 then fieldpos = fieldpos - 1 end
			elseif newchar == 2 then
				if fieldpos < string.len(newfield) then fieldpos = fieldpos + 1 end
			elseif newchar == 8 then
				if fieldpos > 0 then
					newfieldend = string.sub(newfield, fieldpos + 1, string.len(newfield))
					newfieldbeg = string.sub(newfield, 0, fieldpos - 1)
					newfield = newfieldbeg .. newfieldend
					fieldpos = fieldpos - 1
				end
			elseif newchar == 9 then
				if fieldpos < string.len(newfield) then
					newfieldend = string.sub(newfield, fieldpos + 2, string.len(newfield))
					newfieldbeg = string.sub(newfield, 0, fieldpos)
					newfield = newfieldbeg .. newfieldend
				end
			elseif newchar == 0 then
			else
				if fieldedit==1 then
					if string.len(newfield)<maxnamelen then
						newfieldend = string.sub(newfield, fieldpos + 1, string.len(newfield))
						newfieldbeg = string.sub(newfield, 0, fieldpos)
						newfield = newfieldbeg .. string.char(newchar) .. newfieldend
						fieldpos = fieldpos + 1
					end
				else
					if string.len(newfield)<maxmemolen then
						newfieldend = string.sub(newfield, fieldpos + 1, string.len(newfield))
						newfieldbeg = string.sub(newfield, 0, fieldpos)
						newfield = newfieldbeg .. string.char(newchar) .. newfieldend
						fieldpos = fieldpos + 1
					end
				end
			end
			if fieldedit == 1 then
				field = newfield
			else
				field2 = newfield
			end
		end
		keyboard:Display()
	end
	screen.waitVblankStart()
	screen:flip()
	oldpad=pad
end
