--Activate USB for debugging
System.usbDiskModeActivate()

-- Images
background = Image.load("./images/background.png")
prescreen = Image.createEmpty(480,272)
start = Image.load("./images/startmenu.png")

-- Colors
red = Color.new(255, 250, 250)
black = Color.new(0, 0, 0)

-- Default memo name and text
field = "Memo name"
field2 = "Memo text"

-- Default memos shown
mtop=3
mbot=21

function readmemos()
	-- Read current directory
	memolist={}
	memolist=System.listDirectory("./memos/")
	nummemos=table.getn(memolist)
	
	-- Read memo contents and store in table
	memotext={}
	for k=3,nummemos do
		file=io.open("./memos/"..memolist[k].name,"r")
		memotext[k-2]=file:read("*a")
		file:close()
	end
	
	tfread=true
end


-- Selection Screen Function

function SelectionScreen()

	-------------- Display --------------
	-- Display list of memos in left pane and memo contents in right pane
	if nummemos>2 then
		if nummemos<21 then
			mbot=nummemos
		end
		for k=mtop,mbot do
		    if k==selection then
				prescreen:print(17,40+10*(k-mtop),memolist[k].name,red)
		    else
				prescreen:print(17,40+10*(k-mtop),memolist[k].name,black)
		    end
		end
		prescreen:print(203,40,memotext[selection-2],black)
	end
  
  
	-------------- Controls ------------
	-- Highlight currently selected memo
	if pad:down() and oldpad:down()~=pad:down() then
		selection=selection+1
	end
	if pad:up() and oldpad:up()~=pad:up() then
		selection=selection-1
	end
	-- Select current option
	if pad:cross() and oldpad:cross()~=pad:cross() and nummemos>2 then
		screen.waitVblankStart(15)
		while true do
			screen:clear()
			screen:blit(0,0,prescreen)
			pad=Controls.read()
			if pad:up() and oldpad:up()~=pad:up() then
				selection2=selection2-1
			elseif pad:down() and oldpad:down()~=pad:down() then
				selection2=selection2+1
			end
			if selection2<1 then selection2=3 end
			if selection2>3 then selection2=1 end
			local choice={"Edit","Delete","Cancel"}
			local chcol={black,black,black}
			chcol[selection2]=red
			screen:blit(190,106,start)
			screen:print(224,117,choice[1],chcol[1])
			screen:print(216,127,choice[2],chcol[2])
			screen:print(216,137,choice[3],chcol[3])
			if pad:cross() and oldpad:cross()~=pad:cross() then
				if selection2==1 then
				    field = memolist[selection].name
					field2 = memotext[selection-2]
					screen.waitVblankStart(10)
				    dofile("create.lua")
				elseif selection2==2 then
					System.removeFile("./memos/"..memolist[selection].name)
					table.remove(memotext,selection-2)
					if selection==nummemos then selection=selection-1 end
					tfread=false
				end
				break
			end
			screen.waitVblankStart()
			screen:flip()
			oldpad=pad
		end
	end
	-- Create new memo
	if pad:square() and oldpad:square()~=pad:square() then
		screen.waitVblankStart(10)
	    dofile("create.lua")
	end

	if pad:circle() and oldpad:circle()~=pad:circle() then
		screen.waitVblankStart(10)
	    dofile("help.lua")
	end
  
  -- Cycle selections
	if selection<3 then
		selection=nummemos
	elseif selection>nummemos then
		selection=3
	end
	if selection<mtop then
		mtop=selection
		mbot=selection+18
	elseif selection>mbot then
		mtop=selection-18
		mbot=selection
	end
end



-- Testing selection screen function
selection=3
selection2=1
tfread=false
oldpad=Controls.read()

while true do
	screen:clear()
	prescreen:blit(0, 0, background)
	pad=Controls.read()
	if not tfread then
		readmemos()
	end
  
	SelectionScreen()
  
	if pad:triangle() and oldpad:triangle()~=pad:triangle() then
		System.Quit()
	end
	
	screen:blit(0,0,prescreen)
	screen.waitVblankStart()
	screen:flip()
	oldpad=pad
end
